]> Sergey Matveev's repositories - zsh-autoenv.git/blob - autoenv.zsh
_autoenv_hash_pair: use sha1sum for v1 hashes
[zsh-autoenv.git] / autoenv.zsh
1 # Initially based on
2 # https://github.com/joshuaclayton/dotfiles/blob/master/zsh_profile.d/autoenv.zsh
3
4 # File to store confirmed authentication into.
5 # This handles the deprecated, old location(s).
6 if [[ -z $AUTOENV_AUTH_FILE ]]; then
7   if [[ -n $AUTOENV_ENV_FILENAME ]]; then
8     echo "zsh-autoenv: using deprecated setting for AUTOENV_AUTH_FILE from AUTOENV_ENV_FILENAME." >&2
9     echo "Please set AUTOENV_AUTH_FILE instead." >&2
10     AUTOENV_AUTH_FILE=$AUTOENV_ENV_FILENAME
11   else
12     if [[ -n $XDG_DATA_HOME ]]; then
13       AUTOENV_AUTH_FILE=$XDG_DATA_HOME/autoenv_auth
14     else
15       AUTOENV_AUTH_FILE=~/.local/share/autoenv_auth
16     fi
17     if [[ -f ~/.env_auth ]]; then
18       echo "zsh-autoenv: using deprecated location for AUTOENV_AUTH_FILE." >&2
19       echo "Please move it: mv ~/.env_auth ${(D)AUTOENV_AUTH_FILE}" >&2
20       AUTOENV_AUTH_FILE=~/.env_auth
21     fi
22   fi
23 fi
24
25 # Name of the file to look for when entering directories.
26 : ${AUTOENV_FILE_ENTER:=.autoenv.zsh}
27
28 # Name of the file to look for when leaving directories.
29 # Requires AUTOENV_HANDLE_LEAVE=1.
30 : ${AUTOENV_FILE_LEAVE:=.autoenv_leave.zsh}
31
32 # Look for zsh-autoenv "enter" files in parent dirs?
33 : ${AUTOENV_LOOK_UPWARDS:=1}
34
35 # Handle leave events when changing away from a subtree, where an "enter"
36 # event was handled?
37 : ${AUTOENV_HANDLE_LEAVE:=1}
38
39 # Enable debugging. Multiple levels are supported (max 2).
40 : ${AUTOENV_DEBUG:=0}
41
42 # (Temporarily) disable zsh-autoenv. This gets looked at in the chpwd handler.
43 : ${AUTOENV_DISABLED:=0}
44
45 # Public helper functions, which can be used from your .autoenv.zsh files:
46
47 # Source the next .autoenv.zsh file from parent directories.
48 # This is useful if you want to use a base .autoenv.zsh file for a directory
49 # subtree.
50 autoenv_source_parent() {
51   local look_until=${1:-/}
52   local parent_env_file=$(_autoenv_get_file_upwards \
53     ${autoenv_env_file:h} ${AUTOENV_FILE_ENTER} $look_until)
54
55   if [[ -n $parent_env_file ]] \
56     && _autoenv_check_authorized_env_file $parent_env_file; then
57     _autoenv_debug "Calling autoenv_source_parent: parent_env_file:$parent_env_file"
58     _autoenv_source $parent_env_file enter
59   fi
60 }
61
62 # Internal functions. {{{
63 # Internal: stack of loaded env files (i.e. entered directories). {{{
64 typeset -g -a _autoenv_stack_entered
65 # -g: make it global, this is required when used with antigen.
66 typeset -g -A _autoenv_stack_entered_mtime
67
68 # Add an entry to the stack, and remember its mtime.
69 _autoenv_stack_entered_add() {
70   local env_file=$1
71
72   # Remove any existing entry.
73   _autoenv_stack_entered_remove $env_file
74
75   # Append it to the stack, and remember its mtime.
76   _autoenv_debug "[stack] adding: $env_file" 2
77   _autoenv_stack_entered+=($env_file)
78   _autoenv_stack_entered_mtime[$env_file]=$(_autoenv_get_file_mtime $env_file)
79 }
80
81 # zstat_mime helper, conditionally defined.
82 # Load zstat module, but only its builtin `zstat`.
83 if ! zmodload -F zsh/stat b:zstat 2>/dev/null; then
84   # If the module is not available, define a wrapper around `stat`, and use its
85   # terse output instead of format, which is not supported by busybox.
86   # Assume '+mtime' as $1.
87   _autoenv_get_file_mtime() {
88     # setopt localoptions pipefail
89     local stat
90     stat=$(stat -t $1 2>/dev/null)
91     if [[ -n $stat ]]; then
92       echo ${${(s: :)stat}[13]}
93     else
94       echo 0
95     fi
96   }
97 else
98   _autoenv_get_file_mtime() {
99     zstat +mtime $1 2>/dev/null || echo 0
100   }
101 fi
102
103 # Remove an entry from the stack.
104 _autoenv_stack_entered_remove() {
105   local env_file=$1
106   _autoenv_debug "[stack] removing: $env_file" 2
107   _autoenv_stack_entered[$_autoenv_stack_entered[(i)$env_file]]=()
108   _autoenv_stack_entered_mtime[$env_file]=
109 }
110
111 # Is the given entry already in the stack?
112 # This checks for the env_file ($1) as-is and with symlinks resolved.
113 _autoenv_stack_entered_contains() {
114   local env_file=$1
115   local f i
116   if (( ${+_autoenv_stack_entered[(r)${env_file}]} )); then
117     # Entry is in stack.
118     f=$env_file
119   else
120     for i in $_autoenv_stack_entered; do
121       if [[ ${i:A} == ${env_file:A} ]]; then
122         # Entry is in stack (compared with resolved symlinks).
123         f=$i
124         break
125       fi
126     done
127   fi
128   if [[ -n $f ]]; then
129     if [[ $_autoenv_stack_entered_mtime[$f] == $(_autoenv_get_file_mtime $f) ]]; then
130       # Entry has the expected mtime.
131       return
132     fi
133   fi
134   return 1
135 }
136 # }}}
137
138 # Internal function for debug output. {{{
139 _autoenv_debug() {
140   local level=${2:-1}
141   if (( AUTOENV_DEBUG < level )); then
142     return
143   fi
144   local msg="$1"  # Might trigger a bug in Zsh 5.0.5 with shwordsplit.
145   # Load zsh color support.
146   if [[ -z $color ]]; then
147     autoload colors
148     colors
149   fi
150   # Build $indent prefix.
151   local indent=
152   if [[ $_autoenv_debug_indent -gt 0 ]]; then
153     for i in {1..${_autoenv_debug_indent}}; do
154       indent="  $indent"
155     done
156   fi
157
158   # Split $msg by \n (not newline).
159   lines=(${(ps:\\n:)msg})
160   for line in $lines; do
161     echo -n "${fg_bold[blue]}[autoenv]${fg_no_bold[default]} " >&2
162     echo ${indent}${line} >&2
163   done
164 }
165 # }}}
166
167
168 # Generate hash pair for a given file ($1) and version ($2).
169 # A fixed hash value can be given as 3rd arg, but is used with tests only.
170 # The format is ":$file:$hash:$version".
171 _autoenv_hash_pair() {
172   local env_file=${1:A}
173   local cksum_version=${2:-2}
174   local env_cksum=${3:-}
175   ret_pair=
176   if [[ -z $env_cksum ]]; then
177     if ! [[ -e $env_file ]]; then
178       echo "Missing file argument for _autoenv_hash_pair!" >&2
179       return 1
180     fi
181     if [[ $cksum_version = 2 ]]; then
182       # Get the output from `cksum` and join the first two words with a dot.
183       env_cksum=${(j:.:)${:-$(cksum "$env_file")}[1,2]}
184     elif [[ $cksum_version = 1 ]]; then
185       env_cksum=$(sha1sum $env_file | cut -d' ' -f1)
186     else
187       echo "Invalid version argument (${cksum_version}) for _autoenv_hash_pair!" >&2
188       return 1
189     fi
190   fi
191   ret_pair=":${env_file}:${env_cksum}:${cksum_version}"
192 }
193
194
195 # Checks for the existence of a hash signature in the auth file
196 _autoenv_authorized_pair() {
197   local pair=$1
198   test -f $AUTOENV_AUTH_FILE \
199     && \grep -qF $pair $AUTOENV_AUTH_FILE
200 }
201
202
203 _autoenv_authorized_env_file() {
204   local env_file=$1
205   local ret_pair
206   _autoenv_hash_pair $env_file
207   _autoenv_debug "v2 pair: ${ret_pair}"
208   if ! _autoenv_authorized_pair $ret_pair; then
209     # Fallback for v1 (SHA-1) pairs
210     _autoenv_hash_pair $env_file 1
211     _autoenv_debug "v1 pair: ${ret_pair}"
212     if _autoenv_authorized_pair $ret_pair; then
213       # Upgrade v1 entries to v2
214       _autoenv_authorize $env_file
215     else
216       return 1
217     fi
218   fi
219 }
220
221 _autoenv_authorize() {
222   local env_file=${1:A}
223   _autoenv_deauthorize $env_file
224   [[ -d ${AUTOENV_AUTH_FILE:h} ]] || mkdir -p ${AUTOENV_AUTH_FILE:h}
225   {
226     local ret_pair
227     _autoenv_hash_pair $env_file && echo "$ret_pair"
228   } >>| $AUTOENV_AUTH_FILE
229 }
230
231 # Deauthorize a given filename, by removing it from the auth file.
232 # This uses `test -s` to only handle non-empty files.
233 _autoenv_deauthorize() {
234   local env_file=${1:A}
235   if [[ -s $AUTOENV_AUTH_FILE ]]; then
236     \grep -vF :${env_file}: $AUTOENV_AUTH_FILE >| $AUTOENV_AUTH_FILE.tmp
237     \mv $AUTOENV_AUTH_FILE.tmp $AUTOENV_AUTH_FILE
238   fi
239 }
240
241 # This function can be mocked in tests
242 _autoenv_ask_for_yes() {
243   local answer
244
245   # Handle/catch Ctrl-C and return, instead of letting it potentially abort the
246   # shell setup process.
247   setopt localtraps
248   trap 'return 1' INT
249
250   read answer
251   if [[ $answer == "yes" ]]; then
252     return 0
253   else
254     return 1
255   fi
256 }
257
258 # Args: 1: absolute path to env file (resolved symlinks).
259 _autoenv_check_authorized_env_file() {
260   if ! [[ -f $1 ]]; then
261     return 1
262   fi
263   if ! _autoenv_authorized_env_file $1; then
264     echo "Attempting to load unauthorized env file!" >&2
265     command ls -l $1 >&2
266     echo >&2
267     echo "**********************************************" >&2
268     echo >&2
269     command cat $1 >&2
270     echo >&2
271     echo "**********************************************" >&2
272     echo >&2
273     echo -n "Would you like to authorize it? (type 'yes') " >&2
274     # echo "Would you like to authorize it?"
275     # echo "('yes' to allow, 'no' to not being asked again; otherwise ignore it for the shell) "
276
277     if ! _autoenv_ask_for_yes; then
278       return 1
279     fi
280
281     _autoenv_authorize $1
282   fi
283   return 0
284 }
285
286 _autoenv_source() {
287   # Public API for the .autoenv.zsh script.
288   local autoenv_env_file=$1
289   local autoenv_event=$2
290   local autoenv_from_dir=$OLDPWD
291   local autoenv_to_dir=$PWD
292
293   # Source varstash library once.
294   # XXX: pollutes environment with e.g. `stash`, and `autostash` will cause
295   # an overwritten `stash` function to be called!
296   if ! (( $+functions[autostash] )); then
297     if \grep -qE '\b(autostash|autounstash|stash|unstash)\b' $autoenv_env_file; then
298       source ${${funcsourcetrace[1]%:*}:h}/lib/varstash
299     fi
300   fi
301
302   # Source the env file.
303   _autoenv_debug "== SOURCE: $autoenv_event: ${bold_color:-}$autoenv_env_file${reset_color:-} (in $PWD)"
304   (( ++_autoenv_debug_indent ))
305
306   local restore_xtrace
307   if [[ $AUTOENV_DEBUG -gt 2 && ! -o xtrace ]]; then
308     restore_xtrace=1
309     setopt localoptions xtrace
310   fi
311
312   varstash_dir=${autoenv_env_file:h} source $autoenv_env_file
313   if (( restore_xtrace )); then
314     setopt noxtrace
315   fi
316   (( --_autoenv_debug_indent ))
317   _autoenv_debug "== END SOURCE =="
318
319   if [[ $autoenv_event == enter ]]; then
320     _autoenv_stack_entered_add $autoenv_env_file
321   fi
322 }
323
324 _autoenv_get_file_upwards() {
325   local look_from=${1:-$PWD}
326   local look_for=${2:-$AUTOENV_FILE_ENTER}
327   local look_until=${${3:-/}:A}
328
329   # Manually look in parent dirs. An extended Zsh glob should use Y1 for
330   # performance reasons, which is only available in zsh-5.0.5-146-g9381bb6.
331   local last
332   local parent_dir="$look_from/.."
333   local abs_parent_dir
334   while true; do
335     abs_parent_dir=${parent_dir:A}
336     if [[ $abs_parent_dir == $last ]]; then
337       break
338     fi
339     local parent_file="${parent_dir}/${look_for}"
340
341     if [[ -f $parent_file ]]; then
342       if [[ ${parent_file[1,2]} == './' ]]; then
343         echo ${parent_file#./}
344       else
345         echo ${parent_file:a}
346       fi
347       break
348     fi
349
350     if [[ $abs_parent_dir == $look_until ]]; then
351       break
352     fi
353     last=$parent_dir
354     parent_dir="${parent_dir}/.."
355   done
356 }
357
358 autoenv-edit() {
359   local env_file
360   local -a files
361   local -A check
362   check[enter]=$AUTOENV_FILE_ENTER
363   if [[ "$AUTOENV_FILE_ENTER" != "$AUTOENV_FILE_LEAVE" ]]; then
364     check[leave]=$AUTOENV_FILE_LEAVE
365   fi
366   local f t
367   for t f in ${(kv)check}; do
368     env_file="$f"
369     if ! [[ -f $env_file ]]; then
370       env_file=$(_autoenv_get_file_upwards . $f)
371       if [[ -z $env_file ]]; then
372         echo "No $f file found ($t)." >&2
373         continue
374       fi
375       if ! [[ $AUTOENV_LOOK_UPWARDS == 1 ]]; then
376         echo "Note: found $env_file, but AUTOENV_LOOK_UPWARDS is disabled."
377       fi
378     fi
379     files+=($env_file)
380   done
381   if [[ -z "$files" ]]; then
382     return 1
383   fi
384   echo "Editing $files.."
385   local editor
386   editor="${${AUTOENV_EDITOR:-$EDITOR}:-vim}"
387   eval $editor "$files"
388 }
389
390 _autoenv_chpwd_handler() {
391   _autoenv_debug "Calling chpwd handler: PWD=$PWD"
392
393   if (( $AUTOENV_DISABLED )); then
394     _autoenv_debug "Disabled (AUTOENV_DISABLED)."
395     return
396   fi
397
398   local env_file="$PWD/$AUTOENV_FILE_ENTER"
399   _autoenv_debug "Looking for env_file: $env_file"
400
401   # Handle leave event for previously sourced env files.
402   if [[ $AUTOENV_HANDLE_LEAVE == 1 ]] && (( $#_autoenv_stack_entered )); then
403     local prev_file prev_dir
404     for prev_file in ${_autoenv_stack_entered}; do
405       prev_dir=${prev_file:h}
406       if ! [[ ${PWD}/ == ${prev_dir}/* ]]; then
407         local env_file_leave=$prev_dir/$AUTOENV_FILE_LEAVE
408         _autoenv_debug "Handling leave event: $env_file_leave"
409         if _autoenv_check_authorized_env_file $env_file_leave; then
410           varstash_dir=$prev_dir _autoenv_source $env_file_leave leave $prev_dir
411         fi
412
413         # Unstash any autostashed stuff.
414         if (( $+functions[autostash] )); then
415           varstash_dir=$prev_dir autounstash
416         fi
417
418         _autoenv_stack_entered_remove $prev_file
419       fi
420     done
421   fi
422
423   if ! [[ -f $env_file ]] && [[ $AUTOENV_LOOK_UPWARDS == 1 ]]; then
424     env_file=$(_autoenv_get_file_upwards $PWD)
425     if [[ -z $env_file ]]; then
426       _autoenv_debug "No env_file found when looking upwards"
427       return
428     fi
429     _autoenv_debug "Found env_file: $env_file"
430   fi
431
432   # Load the env file only once: check if $env_file is in the stack of entered
433   # directories.
434   if _autoenv_stack_entered_contains $env_file; then
435     _autoenv_debug "Already in stack: $env_file"
436     return
437   fi
438
439   if ! _autoenv_check_authorized_env_file $env_file; then
440     return
441   fi
442
443   # Source the enter env file.
444   _autoenv_debug "Sourcing from chpwd handler: $env_file"
445   _autoenv_source $env_file enter
446 }
447 # }}}
448
449 autoload -U add-zsh-hook
450 add-zsh-hook chpwd _autoenv_chpwd_handler
451
452 # Look in current directory already.
453 _autoenv_chpwd_handler